<?php
/*
Plugin Name: Twitch Status for WordPress
Plugin URI: http://bonfirethemes.com/
Description: Setup and customize under Appearance → Customize → Twitch Status for WordPress Plugin
Version: 1.2
Author: Bonfire Themes
Author URI: http://bonfirethemes.com/
Text Domain: tsw
Domain Path: /languages
License: GPL2
*/

    //
	// WORDPRESS LIVE CUSTOMIZER
	//
	function bonfire_tsw_theme_customizer( $wp_customize ) {
	
        //
        // ADD "Twitch Status for WordPress Plugin" PANEL TO LIVE CUSTOMIZER 
        //
        $wp_customize->add_panel('tsw_panel', array('title' => __('Twitch Status for WordPress Plugin','tsw'),'priority' => 10,));
        
        //
        // ADD "Main Settings" SECTION TO "Twitch Status for WordPress Plugin" PANEL 
        //
        $wp_customize->add_section('tsw_main_section',array('title' => __( 'Main Settings','tsw' ),'panel' => 'tsw_panel','priority' => 1));
        
        /* channel name(s) */
        $wp_customize->add_setting('tsw_channel_names',array('default' => '','sanitize_callback' => 'sanitize_tsw_channel_names',));
        function sanitize_tsw_channel_names($input) {return wp_kses_post(force_balance_tags($input));}
        $wp_customize->add_control('tsw_channel_names',array('type' => 'text','label' => __('Channel name(s)','tsw'),'description' => __('Place channel names in quotes, separated by commas. Example: "ninja","summit1g". Streamers will be ordered randomly but online streamers will be placed before those offline.','tsw'),'section' => 'tsw_main_section',));
        
        /* hide dropdown */
        $wp_customize->add_setting('tsw_hide_dropdown',array('sanitize_callback' => 'sanitize_tsw_hide_dropdown',));
        function sanitize_tsw_hide_dropdown( $input ) { if ( $input == 1 ) { return 1; } else { return ''; } }
        $wp_customize->add_control('tsw_hide_dropdown',array('type' => 'checkbox','label' => __('Hide dropdown','tsw'),'description' => __('If checked, the floating dropdown will be hidden (useful if you only want to show the streamers list via the "Twitch Status Channels" widget under Appearance > Widgets).','tsw'), 'section' => 'tsw_main_section',));
        
        //
        // ADD "Positioning" SECTION TO "Twitch Status for WordPress" PANEL 
        //
        $wp_customize->add_section('tsw_positioning_section',array('title' => __( 'Positioning','tsw' ),'panel' => 'tsw_panel','priority' => 2));
        
        /* absolute position */
        $wp_customize->add_setting('tsw_absolute_position',array('sanitize_callback' => 'sanitize_tsw_absolute_position',));
        function sanitize_tsw_absolute_position( $input ) { if ( $input == 1 ) { return 1; } else { return ''; } }
        $wp_customize->add_control('tsw_absolute_position',array('type' => 'checkbox','label' => __('Absolute positioning','tsw'),'description' => __('If unchecked, fixed positioning is applied.','tsw'), 'section' => 'tsw_positioning_section',));
        
        /* horizontal placemenet */
        $wp_customize->add_setting('tsw_placement_horizontal',array(
            'default' => 'left',
        ));
        $wp_customize->add_control('tsw_placement_horizontal',array(
            'type' => 'select',
            'label' => __('Horizontal placement','tsw'),
            'section' => 'tsw_positioning_section',
            'choices' => array(
                'left' => __('Left','tsw'),
                'right' => __('Right','tsw'),
        ),
        ));
        
        /* top distance */
        $wp_customize->add_setting('tsw_vertical_distance',array('default' => '','sanitize_callback' => 'sanitize_tsw_vertical_distance',));
        function sanitize_tsw_vertical_distance($input) {return wp_kses_post(force_balance_tags($input));}
        $wp_customize->add_control('tsw_vertical_distance',array('type' => 'text','label' => __('Top distance (in pixels)','tsw'),'description' => __('Example: 50 (if empty, defaults to 25).','tsw'),'section' => 'tsw_positioning_section',));
        
        /* left/right distance */
        $wp_customize->add_setting('tsw_horizontal_distance',array('default' => '','v' => 'sanitize_tsw_horizontal_distance',));
        function sanitize_tsw_horizontal_distance($input) {return wp_kses_post(force_balance_tags($input));}
        $wp_customize->add_control('tsw_horizontal_distance',array('type' => 'text','label' => __('Left/right distance (in pixels)','tsw'),'description' => __('Example: 50 (if empty, defaults to 25).','tsw'),'section' => 'tsw_positioning_section',));
        
        //
        // ADD "Button" SECTION TO "Twitch Status for WordPress Plugin" PANEL 
        //
        $wp_customize->add_section('tsw_button_section',array('title' => __( 'Button','tsw' ),'panel' => 'tsw_panel','priority' => 3));

        /* button text */
        $wp_customize->add_setting('tsw_button_text',array('default' => '','sanitize_callback' => 'sanitize_tsw_button_text',));
        function sanitize_tsw_button_text($input) {return wp_kses_post(force_balance_tags($input));}
        $wp_customize->add_control('tsw_button_text',array('type' => 'text','label' => __('Button text','tsw'),'description' => __('If empty, defaults to "Twitch streamers"','tsw'),'section' => 'tsw_button_section',));
        
        /* button icon color */
        $wp_customize->add_setting('tsw_button_icon_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_icon_color',array(
            'label' => __('Icon','tsw'), 'settings' => 'tsw_button_icon_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button icon color (hover) */
        $wp_customize->add_setting('tsw_button_icon_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_icon_hover_color',array(
            'label' => __('Icon (hover)','tsw'), 'settings' => 'tsw_button_icon_hover_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button text color */
        $wp_customize->add_setting('tsw_button_text_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_text_color',array(
            'label' => __('Text','tsw'), 'settings' => 'tsw_button_text_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button text color (hover) */
        $wp_customize->add_setting('tsw_button_text_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_text_hover_color',array(
            'label' => __('Text (hover)','tsw'), 'settings' => 'tsw_button_text_hover_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button arrow color */
        $wp_customize->add_setting('tsw_button_arrow_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_arrow_color',array(
            'label' => __('Arrow','tsw'), 'settings' => 'tsw_button_arrow_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button arrow color (hover) */
        $wp_customize->add_setting('tsw_button_arrow_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_arrow_hover_color',array(
            'label' => __('Arrow (hover)','tsw'), 'settings' => 'tsw_button_arrow_hover_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button background color */
        $wp_customize->add_setting('tsw_button_background_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_background_color',array(
            'label' => __('Background','tsw'), 'settings' => 'tsw_button_background_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button background color (hover) */
        $wp_customize->add_setting('tsw_button_background_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_background_hover_color',array(
            'label' => __('Background (hover)','tsw'), 'settings' => 'tsw_button_background_hover_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button border color */
        $wp_customize->add_setting('tsw_button_border_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_border_color',array(
            'label' => __('Border','tsw'), 'settings' => 'tsw_button_border_color', 'section' => 'tsw_button_section' )
        ));
        
        /* button border color (hover) */
        $wp_customize->add_setting('tsw_button_border_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_button_border_hover_color',array(
            'label' => __('Border (hover)','tsw'), 'settings' => 'tsw_button_border_hover_color', 'section' => 'tsw_button_section' )
        ));
        
        //
        // ADD "Channel List Dropdown" SECTION TO "Twitch Status for WordPress Plugin" PANEL 
        //
        $wp_customize->add_section('tsw_list_section',array('title' => __( 'Channel List Dropdown','tsw' ),'panel' => 'tsw_panel','priority' => 3));
        
        /* background color */
        $wp_customize->add_setting('tsw_list_background_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_background_color',array(
            'label' => __('Background','tsw'), 'settings' => 'tsw_list_background_color', 'section' => 'tsw_list_section' )
        ));
        
        /* background color (hover) */
        $wp_customize->add_setting('tsw_list_name_background_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_name_background_hover_color',array(
            'label' => __('Background (hover)','tsw'), 'settings' => 'tsw_list_name_background_hover_color', 'section' => 'tsw_list_section' )
        ));
        
        /* divider color */
        $wp_customize->add_setting('tsw_list_divider_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_divider_color',array(
            'label' => __('Divider','tsw'), 'settings' => 'tsw_list_divider_color', 'section' => 'tsw_list_section' )
        ));
        
        /* channel name */
        $wp_customize->add_setting('tsw_list_name_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_name_color',array(
            'label' => __('Channel name','tsw'), 'settings' => 'tsw_list_name_color', 'section' => 'tsw_list_section' )
        ));
        
        /* channel name (hover) */
        $wp_customize->add_setting('tsw_list_name_hover_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_name_hover_color',array(
            'label' => __('Channel name (hover)','tsw'), 'settings' => 'tsw_list_name_hover_color', 'section' => 'tsw_list_section' )
        ));
        
        /* channel status (online) */
        $wp_customize->add_setting('tsw_list_online_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_online_color',array(
            'label' => __('Channel status (online)','tsw'), 'settings' => 'tsw_list_online_color', 'section' => 'tsw_list_section' )
        ));
        
        /* channel status (offline) */
        $wp_customize->add_setting('tsw_list_offline_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_offline_color',array(
            'label' => __('Channel status (offline)','tsw'), 'settings' => 'tsw_list_offline_color', 'section' => 'tsw_list_section' )
        ));
        
        /* online indicator */
        $wp_customize->add_setting('tsw_list_online_indicator_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_online_indicator_color',array(
            'label' => __('Online indicator','tsw'), 'settings' => 'tsw_list_online_indicator_color', 'section' => 'tsw_list_section' )
        ));
        
        /* offline indicator */
        $wp_customize->add_setting('tsw_list_offline_indicator_color',array('sanitize_callback'=>'sanitize_hex_color'));
        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'tsw_list_offline_indicator_color',array(
            'label' => __('Offline indicator','tsw'), 'settings' => 'tsw_list_offline_indicator_color', 'section' => 'tsw_list_section' )
        ));

        //
        // ADD "Misc" SECTION TO "Twitch Status for WordPress" PANEL 
        //
        $wp_customize->add_section('tsw_misc_section',array('title' => __( 'Misc','tsw' ),'panel' => 'tsw_panel','priority' => 4));

        /* smaller than */
        $wp_customize->add_setting('tsw_smaller_than',array('sanitize_callback' => 'sanitize_tsw_smaller_than',));
        function sanitize_tsw_smaller_than($input) {return wp_kses_post(force_balance_tags($input));}
        $wp_customize->add_control('tsw_smaller_than',array(
            'type' => 'text',
            'label' => __('Hide at certain width/resolution','tsw'),
            'description' => __('<strong>Example #1:</strong> If you want to show the stream status on desktop only, enter the values as 0 and 500. <br><br> <strong>Example #2:</strong> If you want to show the stream status on mobile only, enter the values as 500 and 5000. <br><br> Feel free to experiment with your own values to get the result that is right for you. If fields are empty, the stream status will be visible at all browser widths and resolutions. <br><br> Hide stream status if browser width or screen resolution (in pixels) is between...','tsw'),
            'section' => 'tsw_misc_section',
        ));
        
        /* larger than */
        $wp_customize->add_setting('tsw_larger_than',array('sanitize_callback' => 'sanitize_tsw_larger_than',));
        function sanitize_tsw_larger_than($input) {return wp_kses_post(force_balance_tags($input));}
        $wp_customize->add_control('tsw_larger_than',array(
            'type' => 'text',
            'description' => __('..and:','tsw'),
            'section' => 'tsw_misc_section',
        ));

	}
	add_action('customize_register', 'bonfire_tsw_theme_customizer');

	//
	// Add stream status to theme
	//
	
	function bonfire_tsw_header() {
	?>

        <!-- BEGIN MAIN WRAPPER (show only if Twitch channel name(s) entered and hide dropdown setting is not enabled) -->
        <?php if( get_theme_mod('tsw_hide_dropdown') == '') { ?>
            <?php if( get_theme_mod('tsw_channel_names') != '') { ?>
            <div class="tsw-wrapper">
                <div class="tsw-button">
                    <div class="tsw-icon-twitch"></div>
                    <div class="tsw-button-text">
                        <?php if( get_theme_mod('tsw_button_text') != '') { ?>
                            <?php echo get_theme_mod('tsw_button_text'); ?>
                        <?php } else { ?>
                            <?php esc_html_e('Twitch streamers','tsw'); ?>
                        <?php } ?>
                    </div>
                </div>
                <div class="tsw-wrapper-inner">
                    <div class="tsw-users-wrapper">
                        <?php include( plugin_dir_path( __FILE__ ) . 'include.php'); ?>
                    </div>
                </div>
            </div>
            <?php } ?>
        <?php } ?>
        <!-- END MAIN WRAPPER (show only if Twitch channel name(s) entered and hide dropdown setting is not enabled) -->
        
        <script>
        var channels = [
            <?php echo get_theme_mod('tsw_channel_names'); ?>
        ];
        var url = "https://api.twitch.tv/kraken/";
        jQuery.ajaxSetup({
            headers : {
                'Client-ID': 'ls2awgx5gfg9m1q6iopdqb1b7d0y6a'
            }
        });

        channels.forEach(function(channel) {
        function makeURL(type, name) {
            return url + type + "/" + name;
        };
        jQuery.getJSON(makeURL("streams", channel), function(data) {
            var game,
            status;
            if(data.stream === null) {
                game = "Offline";
                status = "offline";
            } else {
                game = data.stream.game;
                status = "online";
            };
            jQuery.getJSON(makeURL("channels", channel), function(data) {
                var logo = data.logo,
                name = data.display_name != null ? data.display_name : channel;
                var html = '<a class="tsw-user ' + status + '" href="' + data.url + '" target="_blank"><div class="tsw-logo"><img src="' + logo + '"></div><div class="tsw-details-wrapper"><div class="tsw-name">' + name + '</div><div class="tsw-game-played">' + game + '</div></div></a>';
                status === "online" ? jQuery(".tsw-users-inner").prepend(html) : jQuery(".tsw-users-inner").append(html);
            });
        });
        });
        </script>

	<?php
	}
	add_action('wp_footer','bonfire_tsw_header');
    
    //
	// Add 'Settings' link to plugin page
	//
    add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'add_tsw_action_links' );
    function add_tsw_action_links ( $links ) {
        $mylinks = array(
        '<a href="' . admin_url( 'customize.php?autofocus[panel]=tsw_panel' ) . '">Settings</a>',
        );
    return array_merge( $links, $mylinks );
    }

	//
	// ENQUEUE tsw.css
	//
	function bonfire_tsw_css() {
		wp_register_style( 'bonfire-tsw-css', plugins_url( '/tsw.css', __FILE__ ) . '', array(), '1', 'all' );
		wp_enqueue_style( 'bonfire-tsw-css' );
	}
	add_action( 'wp_enqueue_scripts', 'bonfire_tsw_css' );
    
    //
	// ENQUEUE tsw.js
	//
	function bonfire_tsw_js() {
		wp_register_script( 'bonfire-tsw-js', plugins_url( '/tsw.js', __FILE__ ) . '', array( 'jquery' ), '1', true );  
		wp_enqueue_script( 'bonfire-tsw-js' );
	}
	add_action( 'wp_enqueue_scripts', 'bonfire_tsw_js' );

	//
	// ENQUEUE Google WebFonts
	//
    function bonfire_tsw_fonts_url() {
		$font_url = '';

		if ( 'off' !== _x( 'on', 'Google font: on or off', 'tsw' ) ) {
			$font_url = add_query_arg( 'family', urlencode( 'Roboto:500' ), "//fonts.googleapis.com/css" );
		}
		return $font_url;
	}
	function bonfire_tsw_scripts() {
		wp_enqueue_style( 'tsw-fonts', bonfire_tsw_fonts_url(), array(), '1.0.0' );
	}
	add_action( 'wp_enqueue_scripts', 'bonfire_tsw_scripts' );
    
    //
	// Translation-ready
	//
    function tsw_load_plugin_textdomain() {
        load_plugin_textdomain( 'tsw', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
    }
    add_action( 'plugins_loaded', 'tsw_load_plugin_textdomain' );

    //
	// Widget for channels list
	//
    class tsw_channels_widget extends WP_Widget {
        // Main constructor
        public function __construct() {
            parent::__construct(
                'tsw_channels_widget',
                __( 'Twitch Status Channels', 'tsw' ),
                array(
                    'description' => esc_html__( 'Set up channels under Appearance > Customize > Twitch Status for WordPress Plugin', 'tsw' ),
                    'customize_selective_refresh' => true,
                )
            );
        }
        // The widget form (for the backend)
        public function form( $instance ) {
            // widget defaults
            $defaults = array(
                'title'    => '',
            );
            
            // Parse current settings with defaults
            extract( wp_parse_args( ( array ) $instance, $defaults ) ); ?>

            <!-- Widget title -->
            <p>
                <label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php _e( 'Widget Title', 'tsw' ); ?></label>
                <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
            </p>

        <?php }
        // Update widget settings
        public function update( $new_instance, $old_instance ) {
            $instance = $old_instance;
            $instance['title']    = isset( $new_instance['title'] ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
            return $instance;
        }
        // Display the widget
        public function widget( $args, $instance ) {
            extract( $args );
            // Check the widget options
            $title    = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : '';
            echo $before_widget;
            // Display the widget on the front end
                // Display widget title if defined
                if ( $title ) {
                    echo $before_title . $title . $after_title;
                } ?>
                <div class="tsw-wrapper-inner">
                    <?php include( plugin_dir_path( __FILE__ ) . 'include.php'); ?>
                </div>
            <?php echo $after_widget;
        }
    }
    // Register the widget
    function tsw_register_channels_widget() {
        register_widget( 'tsw_channels_widget' );
    }
    add_action( 'widgets_init', 'tsw_register_channels_widget' );

    //
	// Widget for video + chatbox embeds
	//
    class tsw_embed_widget extends WP_Widget {
        // Main constructor
        public function __construct() {
            parent::__construct(
                'tsw_embed_widget',
                __( 'Twitch Status Embed', 'tsw' ),
                array(
                    'description' => esc_html__( 'Embed a specified Twitch channel', 'tsw' ),
                    'customize_selective_refresh' => true,
                )
            );
        }
        // The widget form (for the backend)
        public function form( $instance ) {
            // widget defaults
            $defaults = array(
                'title'    => '',
                'text'     => '',
                'checkbox' => '',
            );
            
            // Parse current settings with defaults
            extract( wp_parse_args( ( array ) $instance, $defaults ) ); ?>

            <!-- Widget title -->
            <p>
                <label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php _e( 'Widget Title', 'tsw' ); ?></label>
                <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
            </p>

            <!-- Channel name -->
            <p>
                <label for="<?php echo esc_attr( $this->get_field_id( 'text' ) ); ?>"><?php _e( 'Channel:', 'tsw' ); ?></label>
                <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'text' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'text' ) ); ?>" type="text" value="<?php echo esc_attr( $text ); ?>" />
            </p>

            <!-- Chat box checkbox -->
            <p>
                <input id="<?php echo esc_attr( $this->get_field_id( 'checkbox' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'checkbox' ) ); ?>" type="checkbox" value="1" <?php checked( '1', $checkbox ); ?> />
                <label for="<?php echo esc_attr( $this->get_field_id( 'checkbox' ) ); ?>"><?php _e( 'Show chat box', 'tsw' ); ?></label>
            </p>

            <!-- Custom chat box height -->
            <p>
                <label for="<?php echo esc_attr( $this->get_field_id( 'chatheight' ) ); ?>"><?php _e( 'Custom chat box height (in pixels):', 'tsw' ); ?></label>
                <input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'chatheight' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'chatheight' ) ); ?>" type="text" value="<?php echo esc_attr( $chatheight ); ?>" />
            </p>

            <!-- Hide when offline checkbox -->
            <p>
                <input id="<?php echo esc_attr( $this->get_field_id( 'checkbox2' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'checkbox2' ) ); ?>" type="checkbox" value="1" <?php checked( '1', $checkbox2 ); ?> />
                <label for="<?php echo esc_attr( $this->get_field_id( 'checkbox2' ) ); ?>"><?php _e( 'Hide when offline', 'tsw' ); ?></label>
            </p>

        <?php }
        // Update widget settings
        public function update( $new_instance, $old_instance ) {
            $instance = $old_instance;
            $instance['title']    = isset( $new_instance['title'] ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
            $instance['text']     = isset( $new_instance['text'] ) ? wp_strip_all_tags( $new_instance['text'] ) : '';
            $instance['checkbox'] = isset( $new_instance['checkbox'] ) ? 1 : false;
            $instance['chatheight']     = isset( $new_instance['chatheight'] ) ? wp_strip_all_tags( $new_instance['chatheight'] ) : '';
            $instance['checkbox2'] = isset( $new_instance['checkbox2'] ) ? 1 : false;
            return $instance;
        }
        // Display the widget
        public function widget( $args, $instance ) {
            extract( $args );
            // Check the widget options
            $title    = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : '';
            $text     = isset( $instance['text'] ) ? $instance['text'] : '';
            $checkbox = ! empty( $instance['checkbox'] ) ? $instance['checkbox'] : false;
            $chatheight     = isset( $instance['chatheight'] ) ? $instance['chatheight'] : '';
            $checkbox2 = ! empty( $instance['checkbox2'] ) ? $instance['checkbox2'] : false;
            echo $before_widget;
            // Display the widget on the front end
                // Display widget title if defined
                if ( $title ) {
                    echo $before_title ?> <span class="tsw-embed-title-<?php echo $text ?> <?php if ( $checkbox2 ) { ?>tsw-widget-embed-hidden<?php } ?>"><?php echo $title ?></span> <?php $after_title;
                }
                // Display text field
                if ( $text ) {
                    ?>
                    
                    <div class="tsw-video-embed <?php if ( $checkbox2 ) { ?>tsw-widget-embed-hidden<?php } ?> tsw-embed-<?php echo $text ?>"><iframe src="https://player.twitch.tv/?channel=<?php echo $text ?>" frameborder="0" allowfullscreen="true" scrolling="no"></iframe></div>
                    
                    <?php if ( $checkbox2 ) { ?>
                        <script>
                        jQuery(function(){
                            jQuery.getJSON('https://api.twitch.tv/kraken/streams/<?php echo $text ?>', function(channel) {
                            if (channel["stream"] == null) { 
                                jQuery(".tsw-embed-<?php echo $text ?>, .tsw-chat-embed-<?php echo $text ?>").remove();
                                jQuery(".tsw-embed-title-<?php echo $text ?>").parent().hide();
                            } else {
                                jQuery(".tsw-embed-title-<?php echo $text ?>, .tsw-embed-<?php echo $text ?>, .tsw-chat-embed-<?php echo $text ?>").removeClass("tsw-widget-embed-hidden");
                            }
                            });
                        });
                        </script>
                    <?php } ?>
                     
                    <?php
                }
                // Display chat box if checkbox is selected
                if ( $checkbox ) { ?>
                    
                    <div class="tsw-chat-embed <?php if ( $checkbox2 ) { ?>tsw-widget-embed-hidden<?php } ?> tsw-chat-embed-<?php echo $text ?>"><iframe style="height:<?php echo $chatheight ?>px;" src="https://www.twitch.tv/embed/<?php echo $text ?>/chat?darkpopout" frameborder="0" scrolling="no"></iframe></div>
                    
                <?php }
            echo $after_widget;
        }
    }
    // Register the widget
    function tsw_register_embed_widget() {
        register_widget( 'tsw_embed_widget' );
    }
    add_action( 'widgets_init', 'tsw_register_embed_widget' );

    //
	// Insert customization options into the header
	//
	function bonfire_tsw_customize() {
	?>
		<!-- BEGIN CUSTOM COLORS (WP THEME CUSTOMIZER) -->
        <style>
        /* button colors */
        .tsw-icon-twitch {
            color:<?php echo get_theme_mod('tsw_button_icon_color'); ?>;
        }
        .tsw-active .tsw-icon-twitch,
        .tsw-button:hover .tsw-icon-twitch {
            color:<?php echo get_theme_mod('tsw_button_icon_hover_color'); ?>;
        }
        .tsw-button-text {
            color:<?php echo get_theme_mod('tsw_button_text_color'); ?>;
        }
        .tsw-active .tsw-button-text,
        .tsw-button:hover .tsw-button-text {
            color:<?php echo get_theme_mod('tsw_button_text_hover_color'); ?>;
        }
        .tsw-button::before {
            border-top-color:<?php echo get_theme_mod('tsw_button_arrow_color'); ?>;
        }
        .tsw-active .tsw-button::before,
        .tsw-button:hover::before {
            border-top-color:<?php echo get_theme_mod('tsw_button_arrow_hover_color'); ?>;
        }
        .tsw-button {
            border-color:<?php echo get_theme_mod('tsw_button_border_color'); ?>;
            background-color:<?php echo get_theme_mod('tsw_button_background_color'); ?>;
        }
        .tsw-active .tsw-button,
        .tsw-button:hover {
            border-color:<?php echo get_theme_mod('tsw_button_border_hover_color'); ?>;
            background-color:<?php echo get_theme_mod('tsw_button_background_hover_color'); ?>;
        }
        
        /* streamer list */
        .tsw-wrapper { background-color:<?php echo get_theme_mod('tsw_list_background_color'); ?>;}
        .tsw-user { border-bottom-color:<?php echo get_theme_mod('tsw_list_divider_color'); ?>; }
        .tsw-name { color:<?php echo get_theme_mod('tsw_list_name_color'); ?>; }
        .tsw-user:hover .tsw-name { color:<?php echo get_theme_mod('tsw_list_name_hover_color'); ?>; }
        .tsw-user:hover { background-color:<?php echo get_theme_mod('tsw_list_name_background_hover_color'); ?>; }
        /* status */
        .tsw-wrapper-inner .online .tsw-game-played { color:<?php echo get_theme_mod('tsw_list_online_color'); ?>; }
        .tsw-wrapper-inner .offline .tsw-game-played { color:<?php echo get_theme_mod('tsw_list_offline_color'); ?>; }
        /* online/offline indicators */
        .tsw-wrapper-inner .online .tsw-game-played::before { background-color:<?php echo get_theme_mod('tsw_list_online_indicator_color'); ?>; }
        .tsw-wrapper-inner .offline .tsw-game-played::before { background-color:<?php echo get_theme_mod('tsw_list_offline_indicator_color'); ?>; }

        /* absolute positioning */
        <?php if( get_theme_mod('tsw_absolute_position') != '') { ?>
        .tsw-wrapper { position:absolute; }
        <?php } ?>
        
        /* distances (if at top) */
        .tsw-wrapper {
            top:<?php echo get_theme_mod('tsw_vertical_distance'); ?>px;
            left:<?php echo get_theme_mod('tsw_horizontal_distance'); ?>px;
        }
        
        /* right placement + distances */
        <?php $bonfire_tsw_placement_horizontal = get_theme_mod('tsw_placement_horizontal'); if($bonfire_tsw_placement_horizontal != '') { switch ($bonfire_tsw_placement_horizontal) { case 'right': ?>
        .tsw-wrapper {
            left:auto;
            right:<?php if( get_theme_mod('tsw_horizontal_distance') != '') { ?><?php echo get_theme_mod('tsw_horizontal_distance'); ?><?php } else { ?>25<?php } ?>px;
        }
        <?php break; } } ?>
        
        /* hide between resolutions */
		@media ( min-width:<?php echo get_theme_mod('tsw_smaller_than'); ?>px) and (max-width:<?php echo get_theme_mod('tsw_larger_than'); ?>px) {
			.tsw-wrapper { display:none !important; }
		}
		</style>
		<!-- END CUSTOM COLORS (WP THEME CUSTOMIZER) -->
	
	<?php
	}
	add_action('wp_head','bonfire_tsw_customize');

?>